/* K6-18@NCbN\[gi擪^^vf\[gĒl𐕎ƂFċAŁj*/

/* {vÕRpCɂ"IntStack.h""IntStack.c"Kvł */

#include <stdio.h>
#include <stdlib.h>
#include "IntStack.h"

#define swap(type, x, y) do { type t = x; x = y; y = t; } while (0)

/*--- x[a], x[b], x[c]\[gil̃CfbNXԋpj---*/
int sort3elem(int x[], int a, int b, int c)
{
	if (x[b] < x[a]) swap(int, x[b], x[a]);
	if (x[c] < x[b]) swap(int, x[c], x[b]);
	if (x[b] < x[a]) swap(int, x[b], x[a]);
	return b;
}

/*--- P}\[g ---*/
void insertion(int a[], int n)
{
	int i, j;

	for (i = 1; i < n; i++) {
		int tmp = a[i];
		for (j = i; j > 0 && a[j - 1] > tmp; j--)
			a[j] = a[j - 1];
		a[j] = tmp;
	}
}

/*--- NCbN\[giċAŁFvf9ȉɂȂƒP}\[gɐ؂肩j---*/
void quick(int a[], int left, int right)
{
	IntStack lstack;		/* ׂ擪vf̓ỸX^bN */
	IntStack rstack;		/* ׂvf̓ỸX^bN */

	Initialize(&lstack, right - left + 1);
	Initialize(&rstack, right - left + 1);

	Push(&lstack, left);
	Push(&rstack, right);

	while (!IsEmpty(&lstack)) {
		int pl = (Pop(&lstack, &left),  left);		/* J[\ */
		int pr = (Pop(&rstack, &right), right);		/* EJ[\ */
		int x;										/*  */

		if (right - left < 9)
			insertion(&a[left], right - left + 1);
		else {
			int m = sort3elem(a, pl, (pl + pr) / 2, pr);
			x = a[m];
			swap(int, a[m], a[right - 1]);
			pl++;
			pr -= 2;

			do {
				while (a[pl] < x) pl++;
				while (a[pr] > x) pr--;
				if (pl <= pr) {
					swap(int, a[pl], a[pr]);
					pl++;
					pr--;
				}
			} while (pl <= pr);

			if (pr - left < right - pl) {
				swap(int, pl, left);
				swap(int, pr, right);
			}
			if (left < pr) {
				Push(&lstack, left);	/* O[v͈̔͂ */
				Push(&rstack, pr);		/* YvbV */
			}
			if (pl < right) {
				Push(&lstack, pl);		/* EO[v͈̔͂ */
				Push(&rstack, right);	/* YvbV */
			}
		}
	}
}

int main(void)
{
	int i, nx;
	int *x;		/* z̐擪vfւ̃|C^ */

	puts("NCbN\[g");
	printf("vf : ");
	scanf("%d", &nx);
	x = calloc(nx, sizeof(int));

	for (i = 0; i < nx; i++) {
		printf("x[%d] : ", i);
		scanf("%d", &x[i]);
	}

	quick(x, 0, nx - 1);	/* zxNCbN\[g */

	puts("Ƀ\[g܂B");
	for (i = 0; i < nx; i++)
		printf("x[%d] = %d\n", i, x[i]);

	free(x);	/* z */

	return 0;
}
