/* K6-20@ėpNCbN\[giqsort֐ɏdlj*/

#include <stdio.h>
#include <stdlib.h>

/*--- x, y̎wnoCg̗̈ ---*/
static void memswap(void *x, void *y, size_t n)
{
	unsigned char *a = (unsigned char *)x;
	unsigned char *b = (unsigned char *)y;

	for ( ; n--; a++, b++) {
		unsigned char c = *a;
		*a = *b;
		*b = c;
	}
}

/*--- ėpNCbN\[giqsort֐ɏdlj---*/
void q_sort(void *base, size_t nmemb, size_t size,
			int (*compar)(const void *, const void *))
{
	if (nmemb > 0) {
		size_t pl = 0;					/* J[\ */
		size_t pr = nmemb - 1;			/* EJ[\ */
		size_t pv = nmemb;				/*  */
		size_t pt = (pl + pr) / 2;		/* ̍XVl */
		char *v = (char *)base;			/* 擪vfւ̃|C^ */
		char *x;						/* ւ̃|C^ */

		do {
			if (pv != pt) x = &v[(pv = pt) * size];
			while (compar((const void *)&v[pl * size], x) < 0) pl++;
			while (compar((const void *)&v[pr * size], x) > 0) pr--;
			if (pl <= pr) {
				pt = (pl == pv) ? pr : (pr == pv) ? pl : pv;
				memswap(&v[pl * size], &v[pr * size], size);
				pl++;
				if (pr == 0)	/* 0̃fNg */
					goto QuickRight;
				pr--;
			}
		} while (pl <= pr);

		if (0  < pr)      q_sort(&v[0],         pr + 1,     size, compar);
	QuickRight:
		if (pl < nmemb-1) q_sort(&v[pl * size], nmemb - pl, size, compar);
	}
}

/*--- int^̔r֐i\[gpj ---*/
int int_cmp(const int *a, const int *b)
{
	return *a < *b ? -1 : *a > *b ? 1 : 0;
}

int main(void)
{
	int i, nx;
	int *x;		/* z̐擪vfւ̃|C^ */

	printf("q_sortɂ\[g\n");
	printf("vf : ");
	scanf("%d", &nx);
	x = calloc(nx, sizeof(int));	/* vfnxint^z𐶐 */

	for (i = 0; i < nx; i++) {
		printf("x[%d] : ", i);
		scanf("%d", &x[i]);
	}

	q_sort(x,												/* z */
		   nx,												/* vf */
		   sizeof(int),										/* vf̑傫 */
		   (int (*)(const void *, const void *))int_cmp		/* r֐ */
		  );

	puts("Ƀ\[g܂B");
	for (i = 0; i < nx; i++)
		printf("x[%d] = %d\n", i, x[i]);

	free(x);	/* z */

	return 0;
}
