/* K6-20@ėp}[W\[g */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char *buff;			/* Ɨpz */

/*--- ėp}[W\[giCj---*/
void __mergesort(char *a, size_t left, size_t right, size_t size,
			int (*compar)(const void *, const void *))
{
	if (left < right) {
		size_t center = (left + right) / 2;
		size_t p = 0;
		size_t i;
		size_t j = 0;
		size_t k = left;

		__mergesort(a, left, center, size, compar);			/* O}[W\[g */
		__mergesort(a, center + 1, right, size, compar);	/* 㔼}[W\[g */

		for (i = left; i <= center; i++)
			memcpy(&buff[p++ * size], &a[i * size], size);

		while (i <= right && j < p)
			memcpy(&a[k++ * size], compar((const void *)&buff[j * size], (const void *)&a[i * size]) <= 0 ?
								   &buff[j++ * size] : &a[i++ * size], size);

		while (j < p)
			memcpy(&a[k++ * size], &buff[j++ * size], size);
	}
}

/*--- ėp}[W\[g ---*/
void m_sort(void *base, size_t nmemb, size_t size,
			int (*compar)(const void *, const void *))
{
	if (nmemb > 0) {
		buff = calloc(nmemb, size);

		__mergesort(base, 0, nmemb - 1, size, compar);		/* zŜ}[W\[g */

		free(buff);
	}
}

/*--- int^̔r֐i\[gpj ---*/
int int_cmp(const int *a, const int *b)
{
	return *a < *b ? -1 : *a > *b ? 1 : 0;
}

int main(void)
{
	int i, nx;
	int *x;		/* z̐擪vfւ̃|C^ */

	puts("m_sortɂ\[g");
	printf("vfF");
	scanf("%d", &nx);
	x = calloc(nx, sizeof(int));

	for (i = 0; i < nx; i++) {
		printf("x[%d] : ", i);
		scanf("%d", &x[i]);
	}

	m_sort(x,											/* z */
		   nx,											/* vf */
		   sizeof(int),									/* vf̑傫 */
		   (int (*)(const void *, const void *))int_cmp	/* r֐ */
		  );

	puts("Ƀ\[g܂B");
	for (i = 0; i < nx; i++)
		printf("x[%d] = %d\n", i, x[i]);

	free(x);	/* z */

	return 0;
}
