/* |C^ɂ`Xgiwb_j*/

/* K9-1̊֐PurgeƉK9-2̊֐RetrieveList9-1ɒǉ */

#ifndef ___LinkedList
#define ___LinkedList

#include "Member.h"

/*--- m[h ---*/
typedef struct __node {
	Member         data;	/* f[^ */
	struct __node *next;	/* 㑱|C^i㑱m[hւ̃|C^j*/
} Node;

/*--- `Xttg ---*/
typedef struct {
	Node *head;		/* 擪m[hւ̃|C^ */
	Node *crnt;		/* ڃm[hւ̃|C^ */
} List;

/*--- `Xg ---*/
void Initialize(List *list);

/*--- ֐equalɂxƈvƔ肳m[hT ---*/
Node *Search(List *list, const Member *x,
						 int compare(const Member *x, const Member *y));

/*--- 擪n̃m[hւ̃|C^擾 ---*/
Node *Retrieve(List *list, int n);

/*--- 擪Ƀm[h} ---*/
void InsertFront(List *list, const Member *x);

/*--- Ƀm[h} ---*/
void InsertRear(List *list, const Member *x);

/*--- 擪m[h폜 ---*/
void RemoveFront(List *list);

/*--- m[h폜 ---*/
void RemoveRear(List *list);

/*--- ڃm[h폜 ---*/
void RemoveCurrent(List *list);

/*--- Sm[h폜 ---*/
void Clear(List *list);

/*--- r֐ɂēƂ݂Ȃm[h폜 ---*/
void Purge(List *list, int compare(const Member *x, const Member *y));

/*--- ڃm[h̃f[^\ ---*/
void PrintCurrent(const List *list);

/*--- ڃm[h̃f[^\istj---*/
void PrintLnCurrent(const List *list);

/*--- Sm[h̃f[^Xgɕ\ ---*/
void Print(const List *list);

/*--- `Xǧn ---*/
void Terminate(List *list);

#endif
